Redmine - Defect #11975

Undefined status transitions allowed in workflow (author of issue changes when selecting a new
status)

2012-09-27 22:08 - Brian Lindahl

Status: Closed Start date:

Priority: Urgent Due date:

Assignee: Jean-Philippe Lang % Done: 50%
Category: Issues workflow Estimated time: 0.00 hour
Target version: 2141

Resolution: Fixed Affected version: 2.1.0
Description

The modification made back in Revision 5991 allows invalid statuses to be selected by changing the author, and, thus,
new_statuses_allowed_to returns values that it shouldn't. The author changes and new statuses are allowed when the form reloads
when a user selects a new status.

Obviously, there still needs to be a solution for #8472, but the fix shouldn't change the author of an issue, thus breaking the transition
workflow (and possibly other things).

Fix:

diff -rupN redmine-2.1.0/app/controllers/issues_controller.rb redmine-2.1.0-modified/app/controlle
rs/issues_controller.rb
——— redmine-2.1.0/app/controllers/issues_controller.rb 2012-09-16 06:54:12.000000000 —-0600
+++ redmine-2.1.0-modified/app/controllers/issues_controller.rb 2012-09-27 13:51:13.01247177
4 -0600
@@ -393,12 +393,12 @@ private
end
end
@issue.project = @project
- @issue.author = User.current
else
@issue = @project.issues.visible.find(params[:1id])
end

@issue.project = @project
= @issue.author = User.current

# Tracker must be set before custom field values

@issue.tracker ||= @project.trackers.find((params[:issue] && params|[:issue] [:tracker_id]) ||
params|[:tracker_id] || :first)

if @issue.tracker.nil?

For debugging purposes, | added this code to new_statuses_allowed_to, right before the it returns:

status_names = statuses.collect{]|s| s.name + " "}
Rails.logger.error LU S S B B B B B B B i i i b I I I I I I I I i I b b b b b b b b b L]
Rails.logger.error "*****x*x** guthor: #{author.name}"

Rails.logger.error "******x** gtatuses_allowed: #{status_names}}"
Rails'logger.error Mhkdrkhkhkhkhkhhkhhhkhhkhhkhkhhkhkhrhkhhkhkr bk bk bk ok hkrhkhkhkhkrhkrkhxW

Before fix:

Started GET "/redmine/issues/13" for 10.79.23.119 at Thu Sep 27 13:46:34 -0600 2012
Processing by IssuesController#show as HTML
Parameters: {"id"=>"13"}
Current user: development.planner (id=6)
RR R R Ik kb kb b b b b IR b b b b b b b b b b b b b b b b b b b b b b b b b b b b 3
*¥HkrAkxkk* guthor: Reporter 1

kxxxxxx* gtatuses_allowed: New Assigned Discarded }
PR S R S S S R R I I e I I I e I b I g
Rendered issues/_action_menu.html.erb (14.2ms)
Rendered issue_relations/_form.html.erb (3.8ms)
Rendered issues/_relations.html.erb (8.4ms)
Rendered issues/_action_menu.html.erb (4.1ms)
R R b b I b b e b b b b b b b I b b b b b b b i b b b b b b b i b b S i b b b I b b b b 2 3
*¥Hkxkkxkkx guthor: Reporter 1
*¥Hhxkxxkk* statuses_allowed: New Assigned Discarded }
kA kA hkhkdhkhhkhhhkhkhkhkhkhkhkhhkhkrhhkhhkhrhkhkhrhkhkhkhkrhkhkhkhkrkhhhxkhx*k
Rendered issues/_form_custom_fields.html.erb (1.6ms)
Rendered issues/_attributes.html.erb (22.2ms)
Rendered issues/_form.html.erb (181.1ms)
Rendered attachments/_form.html.erb (4.0ms)
Rendered issues/_edit.html.erb (195.0ms)
Rendered issues/_sidebar.html.erb (8.6ms)
Rendered issues/show.html.erb within layouts/base (425.0ms)
Completed 200 OK in 2163ms (Views: 592.3ms | ActiveRecord: 37.3ms)

The form reloads when selecting the 'Assigned’ status, changing the author and allowing the new 'Closed’ status, which
isn't defined as a valid transition for 'Development Engineer':

Started PUT "/redmine/projects/templateproduct/issues/new.js?id=13" for 10.79.23.119 at Thu Sep 27
13:46:42 -0600 2012
Processing by IssuesController#new as JS
Parameters: {"last_journal_ id"=>"", "notes"=>"", "id"=>"13", "project_id"=>"templateproduct", "a
ttachments"=>{"1"=>{"description"=>""}}, "utf8"=>"4", "authenticity_token"=>"kglsV89ngub8Zcxts+t5Q
8HO5GAmmNCF jAXjn8Pj3lo=", "issue"=>{"status_id"=>"3", "priority_id"=>"2", "fixed_version_id"=>"",
"custom_field_values"=>{"5"=>"", "4"=>"n"}  "lock_version"=>"0", "description"=>"", "subject"=>"Rep
orter Feature", "category_id"=>"1", "parent_issue_id"=>""}}
Current user: development.planner (id=6)
R R b I I b b b b b b b b b b b b b b i b b b i b b b 2 b b b i b b b 2 b b b S b b b 2 3
*¥xxkxkxx*x guthor: Development Engineer

kxxxxxx* gtatuses_allowed: New Assigned Discarded Closed }
PR S B S S R R S I I I e I b I e g

R R I b e S b I b I S b b b b b S b S b b b S b S dE S S b I 2h b b b Sb dh 3 2b S

krxxxxx* guthor: Development Engineer

FAxkxxxk gtatuses_allowed: New Assigned Discarded Closed }
R R i e I b b b b b b b b b I b b b i b b b i b b b b b b b i b b b b b b I b b b i 2 3

KA KA AR A IR A A A AN A IR AR A A I A AR AR A A A A A A A A AR A A Ak h K

**xxxxx*x* guthor: Development Engineer

kxxxxxx* gtatuses_allowed: New Assigned Discarded Closed }
PR R S S R S B S B I I I I e I I I e I b I e g

R R I b e S b I b S b b b b b I b S b b b S b b b S S b I b b S b Sb b 3 2b S

xHxxkxx**x guthor: Development Engineer
xHkxkkxkkx statuses_allowed: New Assigned Discarded Closed }
R R i e I b b b b b b b b b I b b b i b b b b b b b I b b b i b b b b b b I b b b b 2 3
Rendered issues/_form_custom_fields.html.erb (1.7ms)
Rendered issues/_attributes.html.erb (39.9ms)
Rendered issues/_form.html.erb (44.5ms)
Rendered issues/_update_form.js.erb (46.6ms)
Completed 200 OK in 256ms (Views: 176.9ms | ActiveRecord: 6.4ms)

After fix:

Started GET "/redmine/issues/13" for 10.79.23.119 at Thu Sep 27 13:44:24 -0600 2012

Processing by IssuesController#show as HTML
Parameters: {"id"=>"13"}
Current user: development.planner (id=6)

PR S S S B R R B R R I I I I I e I b I g

FExkxxxx guthor: Reporter 1

FARxxxxxxk gtatuses_allowed: New Assigned Discarded }

R R i e I b b b b b b b b b I b b b i b b b b b b b b b b b i b b b b b b I b b b b 2 3
Rendered issues/_action_menu.html.erb (15.7ms)
Rendered issue_relations/_form.html.erb (4.5ms)
Rendered issues/_relations.html.erb (9.0ms)
Rendered issues/_action_menu.html.erb (4.1ms)

R R R I b e S b I b S b b b b b S b S b b b 2h b S b Sh b b b b b Sb dh 3 2b S

*xxxxx%x*x guthor: Reporter 1
kAxxAxxx* gtatuses_allowed: New Assigned Discarded }
PR S S S S B R R SR R B R I I I I I I b b g

Rendered issues/_form_custom_fields.html.erb (2.1ms)

Rendered issues/_attributes.html.erb (22.9ms)

Rendered issues/_form.html.erb (192.9ms)

Rendered attachments/_form.html.erb (4.3ms)

Rendered issues/_edit.html.erb (207.0ms)

Rendered issues/_sidebar.html.erb (8.7ms)

Rendered issues/show.html.erb within layouts/base (455.0ms)
Completed 200 OK in 2295ms (Views: 635.5ms | ActiveRecord: 49.3ms)

The form reloads when selecting the 'Assigned’ status, and does *NOT change the author and allow the 'Closed' status: *

Started PUT "/redmine/projects/templateproduct/issues/new.js?id=13" for 10.79.23.119 at Thu Sep 27
13:44:42 -0600 2012
Processing by IssuesController#new as JS
Parameters: {"last_journal_id"=>"", "utf8"=>"4", "issue"=>{"priority_id"=>"2", "category_id"=>"1
", "subject"=>"Reporter Feature", "description"=>"", "parent_issue_id"=>"", "status_id"=>"3", "fix
ed_version_id"=>"", "lock_version"=>"0", "custom_field_valuesg"=>{"5"=>""  "4"=>""}} = M"ayuthenticity
_token"=>"kglsV89ngub8Zcxts+t5Q08H05GAmmNCF jAXjn8Pj31o=", "notes"=>"", "project_id"=>"templateprodu
ct", "attachments"=>{"1"=>{"description"=>""}}, "id"=>"13"}
Current user: development.planner (id=6)
Ak kA hkhkdhhhkdhhkhkhkhkhhkhkhhkhkrhhhhkhrhkhkhkhkhkdhhkrhkhkhkhkhrkhhhxkhx*k
*xxrxxx* guthor: Reporter 1

kAxxxxx* gtatuses_allowed: New Assigned Discarded }
PR B I I I I I I b I I b I b b b b I b b b b g

KA KK AR KA IR A AR AR A AR A AR AR AR A I AR AR AR A AR A AR AN AR AR XK

*x*k*kx** guthor: Reporter 1

FAxxxxxx statuses_allowed: New Assigned Discarded }
Nk kA hkhkkhkhkhhhhkhkhkkhkhhkhkrhkhkrhhkhkhkrhkhkhkhkhkhkhkrhhkhkhhkhhhkhxxk

hhkhkhkhkhkhkhkhkkhk A hkhkrhkhkrhhkhkhhkhhkrhkhkrhkhkrhkkhkhkkhkkhkhxhkhkxkkxk

*xKkkkx*k*k guthor: Reporter 1

kAxxxxx* gtatuses_allowed: New Assigned Discarded }
PR B I I I I I I b I b b b b b b b b b g

KA KK AR KA AR A AR AR A AR A AR AR AR AR A AR AR A AR A AR AR XA A XK

*¥Hkxkkkkx guthor: Reporter 1
*kHkxkxkk*k statuses_allowed: New Assigned Discarded }
Ak hkhkhkhkdhkhkhkhhhkhkhkkhkhhkhkrhkhkrhhkhhkr kb hkhkhkhkrhkhkhkhhkhhhkhkxxk
Rendered issues/_form_custom_fields.html.erb (2.5ms)
Rendered issues/_attributes.html.erb (49.6ms)
Rendered issues/_form.html.erb (54.6ms)
Rendered issues/_update_form.js.erb (57.6ms)
Completed 200 OK in 321ms (Views: 57.2ms | ActiveRecord: 6.7ms)

Associated revisions

Revision 10494 - 2012-09-28 00:12 - Jean-Philippe Lang

Fixed that issue author is assigned with current user when the edit form is updated (#11975).

History

#1 - 2012-09-27 22:12 - Brian Lindahl

Note that | wasn't able to reproduce #8472. It's likely that the root cause of #8472 was resolved in later Redmine versions (post-1.2.0), and that the fix
performed in Revision 5991 is no longer necessary.

However, if the fix is still necessary, one possible solution to fix both problems could be (only speculation, since | can't reproduce #8472):

diff -rupN redmine-2.1.0/app/controllers/issues_controller.rb redmine-2.1.0-modified/app/controllers/issues_co
ntroller.rb

—-—-— redmine-2.1.0/app/controllers/issues_controller.rb 2012-09-16 06:54:12.000000000 -0600
+++ redmine-2.1.0-modified/app/controllers/issues_controller.rb 2012-09-27 14:10:33.108460711 -0600
@@ -398,7 +398,7 Q@ private
end
@issue.project = @project
f @issue.author = User.current
+ @issue.author ||= User.current
# Tracker must be set before custom field values

@issue.tracker ||= @project.trackers.find((params|[:issue]

ker_id] || :first)
if @issue.tracker.nil?

#2 - 2012-09-27 22:23 - Brian Lindahl

&& params|[:issue] [:tracker_id])

| | params|[:trac

Also, in my example, the only people who can perform Discarded -> Closed are the authors of the issue. Thus, the 'Development Engineer' should not

be able to perform this transition. Only when the author is inappropriately changed, is this transition allowed.

#3 - 2012-09-28 00:12 - Jean-Philippe Lang
- Status changed from New to Resolved
- Target version set to 2.1.1

- Resolution set to Fixed

Fixed in r10494 with a test, thanks for pointing this out.

#4 - 2012-09-29 18:31 - Jean-Philippe Lang

- Status changed from Resolved to Closed

Merged into 2.1-stable.

Files

before.JPG 15.5 KB 2012-09-27 Brian Lindahl

after.JPG 15.9 KB 2012-09-27 Brian Lindahl
